dagflood(1)

NAME
dagtuntap - Endace DAG card network daemon

SYNOPSIS
dagtuntap [options]

DESCRIPTION
dagtuntap is a user space daemon which allows ports on a DAG card to be used as kernel network interfaces. DAG cards are not usually seen by the operating system as network devices, and are used only via dagapi(3), pcap(3) APIs.

dagtuntap uses the kernel TUN/TAP driver to create a virtual Ethernet network interface, called tap0 by default. It also opens a DAG card using the native DAG APIs, and then bidirectionally copies packets between the virtual TAP interface and the DAG card.

By default a single tap network interface is created. All traffic received on the DAG stream is captured by the tool, but only packets received on Port A will be sent to the kernel, any other packets are dropped. The user is responsible for configuring any desired filtering and steering to ensure that Port A traffic is delivered to the correct receive stream. When the kernel transmits a packet to the tap interface the created ERF record Interface Id will be set to Port A.

The port option can be used to change which ports are enabled. A separate tap interface will be created for each enabled port. The allports option enables all ports on the card.

This tool is only intended for low packet rate applications such as ARP, link state protocols, and other control traffic. In normal operation dagtuntap will consume only a small amount of CPU time, but the packet rate will be limited to approximately the scheduler rate, or 100-1000 packets per second depending on the kernel configuration. The fastpoll mode allows higher packet rates and lower latency, but the repeated polling will occupy one cpu core, leading to a high reported CPU utilisation.

After the interface is created, it can be configured like any network interface, using ifconfig(8) or a dhcp client.

OPTIONS

-a MAC

--mac MAC
    Set Ethernet MAC address to MAC. The accepted format is xx:xx:xx:xx:xx:xx.

-b

--background
    Fork into background, send output to syslog(3).

-c

--allports
    Use all available physical ports (equivalent to -p ABCD on 4 port card).

-d DEVICE

--device DEVICE
    Use the DAG device referred to by DEVICE. Supported syntax includes 0, dag1, and /dev/dag3 to refer to DAG cards, and 0:2, dag1:2, and /dev/dag2:0 to refer to specific streams on cards.

-f

--fastpoll
    Poll as fast as possible. Increases maximum packet rate at the cost of high cpu utilisation.

-h

-?

--help

--usage
    Display usage (help) information.

-m MTU

--mtu MTU
    Ensure the DAG capture length slen is set to at least MTU. Default 1500.

-p PORTS

--port PORTS
    Physical ports on DAG card to use. Default A. Specify multiple ports as ABCD.

-s STREAM

--txstream STREAM
    Use DAG card transmit stream number STREAM. Default 1.

-t NUM

--tnum NUM
    Create TAP device number NUM. Default 0 creates interface tap0.

-v

--verbose
    Increase output verbosity.

-V

--version
    Display version information.

EXAMPLES
Create interface tap0 using dag0 rx stream 0 tx stream 1 port A:
    dagtuntap

Create interface tap1 using dag4 rx stream 2 tx stream 3 port B:
    dagtuntap -t 1 -d 4:2 -s 3 -p B

Create interface tap0 using dag0 rx stream 0 tx stream 1 port A and tap1 using port C:
    dagtuntap -p AC

Run dagtuntap in the background as a daemon, output goes to syslog(3)
    dagtuntap -b

Run dagtuntap with fast polling for higher performance
    dagtuntap -f

LIMITATIONS
As current DAG card firmware supports only one transmit stream, only one instance of dagtuntap can be run per card. The single instance per card can however support multiple interfaces.

Other applications including dagsnap(1), dagflood(1), or DAG native libpcap can not be run on the DAG card streams which are used by dagtuntap. Libpcap based programs can still capture the kernel interface traffic using the tapN interfaces.

The packet rate is very limited by default, resulting in high latency, making dagtuntap suitable primarily for link state and control protocols. Only Ethernet DAG cards are currently supported.

SEE ALSO
dagsnap(1), dagflood(1).

BUGS
Report bugs to <support@endace.com>.

LAST UPDATED
$Author: sfd $
$Revision: 13719 $
$Date: 2011-01-14 11:30:52 +1300 (Fri, 14 Jan 2011) $

COPYRIGHT
(c) 2002-2010 Endace Technology, Hamilton, New Zealand. All Rights Reserved.